--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_udc.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_udc.h	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,147 @@
+/* name: mausb_udc.h 
+ * description: header file for mausb_udc.h 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.o.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#ifndef __MAUSB_UDC_H 
+#define __MAUSB_UDC_H 
+ 
+#include <linux/timer.h> 
+#include <linux/usb/gadget.h> 
+#include "mausb_state.h" 
+#include "mausb_pkt.h" 
+#include "mausb_msapi.h" 
+#include "mausb_mem.h" /* for mgmt structure */ 
+#include "mausb_const.h" 
+ 
+#define UDC_NAME "mausb udc" 
+#define MAUDC_MAX_NUM_EP 3 
+#define EP_MAX_PACKET 64 /* max number of packets ep can handle */ 
+#define EP_MAX_STREAMS 16 /* max number of streams ep can handle */ 
+#define REQ_BUF_SIZE 64 
+#define CAP_MAX_EP_NUM 3 /* max number of endpoints state can be tracked for */ 
+#define CAP_MAX_DEV_NUM 1 /* max number of devices that can be managed 
+ * note this is 1 because only hubs can have >1 */ 
+#define CAP_DEV_TYPE 0 /* device type: 0 = not an MA USB hub 
+ * 1 = USB 2.0 hub 
+ * 2 = USB 3.1 hub */ 
+#define CAP_MAX_TX_REQS 0x01FF /* max number of outstanding transfer requests 
+ * device can track - arbitrarily chosen */ 
+#define CAP_MAX_MGMT_REQS 0x01F /* max number of outstanding management requests 
+ * device can track - arbitrarily chosen */ 
+ 
+#define MAUDC_DEV_HANDLE 0x1359 /* MA Device handle for the USB device */ 
+ 
+#define MAUDC_DEV_ADDR 0x7D /* USB Device address for the USB device */ 
+ /* Note: MAUDC_DEV_ADDR is arbitrary */ 
+ 
+#define MAUDC_BUS_NUM 0xD /* Bus number to be used in the endpoint handle */ 
+ 
+#define MAUSB_GADGET_TIMEOUT 3 /* time out for gadget driver enqueue request */ 
+ 
+#define maudc_info(udc, fmt, args...) \ 
+ dev_info(udc->gadget.dev.parent , fmt , ## args) 
+#define maudc_dbg(udc, fmt, args...) \ 
+ dev_dbg(udc->gadget.dev.parent , fmt , ## args) 
+#define maudc_warn(udc, fmt, args...) \ 
+ dev_warn(udc->gadget.dev.parent , fmt , ## args) 
+#define maudc_err(udc, fmt, args...) \ 
+ dev_err(udc->gadget.dev.parent , fmt , ## args) 
+ 
+/* function declarations */ 
+void udc_dev_release(struct device *dev); 
+int mausb_udc_probe(struct platform_device *pdev); 
+int mausb_udc_remove(struct platform_device *pdev); 
+int mausb_udc_suspend(struct platform_device *pdev, pm_message_t state); 
+int mausb_udc_resume(struct platform_device *pdev); 
+int check_for_device(int dont_use); 
+ 
+ 
+/* function declarations */ 
+int do_ma_transfer(struct mausb_host_ep *ep, struct mausb_pkt *tx_req, 
+ bool dir_in); 
+/** 
+ * UDC structure 
+ * 
+ * The UDC structure holds all of the per-device data. This includes both the 
+ * media agnostic device data as well as the USB device data. The USB device 
+ * connected to the UDC is considered an integrated USB Device. 
+ * 
+ * @mausb_gadget_ep: An array of all the endpoints for this device. 
+ * @usb_gadget: The device's gadget structure. 
+ * @usb_gadget_driver: the device's driver. 
+ * @ma_dev: The media agnostic device structure. Holds all the 
+ * data common to all media agnostic devices. 
+ * @mausb_dev: Holds media agnostic data that represents a USB device. 
+ * @ms_driver: The MAUSB driver's interface with the media specific 
+ * driver. 
+ * @udc_lock: The 'big' lock. Used to protect this structure's data 
+ * from concurrent access. 
+ * @dev_status: Holds USB device status. 
+ * @suspended: 1 when UDC is suspended, otherwise 0. 
+ * @pullup: 1 when a USB device is connecting to UDC, otherwise 0. 
+ */ 
+struct mausb_udc { 
+ struct mausb_gadget_ep usb_ep[MAUDC_MAX_NUM_EP]; 
+ struct usb_gadget gadget; 
+ struct usb_gadget_driver *driver; 
+ struct ma_dev ma_dev; 
+ struct mausb_dev *mausb_dev; 
+ spinlock_t udc_lock; 
+ u16 dev_status; 
+ unsigned suspended:1; 
+ unsigned pullup:1; 
+}; 
+ 
+#endif 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/Kconfig linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/Kconfig
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/Kconfig	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/Kconfig	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,16 @@
+ 
+menuconfig MAUSB 
+ bool "MA USB drivers" 
+ depends on USB 
+ ---help--- 
+ This option allows you to select from the various MA USB 
+ drivers. Note that a media-specific driver (e.g. tcp or SNAP) 
+ is needed in addition to the media agnostic host or device driver. 
+ 
+ 
+if MAUSB 
+ 
+source "drivers/staging/mausb/drivers/Kconfig" 
+ 
+endif 
+ 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/Makefile linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/Makefile
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/Makefile	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/Makefile	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,2 @@
+obj-y += drivers/ 
+ 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/Android.mk linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/Android.mk
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/Android.mk	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/Android.mk	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,3 @@
+LOCAL_PATH := $(call my-dir) 
+ 
+include $(call all-subdir-makefiles) 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/AUTHORS linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/AUTHORS
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/AUTHORS	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/AUTHORS	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,2 @@
+Sean O. Stalley <sean.stalley [at] intel> 
+Aymen Zayet <aymen.zayet [at] intel> 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/config.mk linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/config.mk
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/config.mk	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/config.mk	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,19 @@
+CROSS_COMPILE ?= arm-none-linux-gnueabi-
+
+SRCDIR = $(shell pwd) 
+DESTDIR = /usr/local/bin 
+ 
+CC = $(CROSS_COMPILE)gcc 
+CFLAGS = -g -ggdb -D __DEBUG 
+LDFLAGS = 
+SHELL = /bin/sh 
+#CFLAGS = -O2 -fomit-frame-pointer 
+ 
+PROJECT_NAME = mausb 
+PROJECT_VERSION = 0.1 
+ 
+BINARY_NAME = $(PROJECT_NAME) 
+ 
+SOURCE_FILES = utils.c connect.c mausb.c 
+ 
+OBJECT_FILES = $(SOURCE_FILES:.c=.o) 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/Makefile linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/Makefile
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/Makefile	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/Makefile	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,14 @@
+include config.mk 
+ 
+.PHONY: $(BINARY_NAME) all clean 
+ 
+all: $(BINARY_NAME) 
+ 
+$(BINARY_NAME): 
+	$(MAKE) -C src/ 
+	cp -rf src/$(BINARY_NAME) . 
+ 
+ 
+clean: 
+	$(MAKE) -C src/ clean 
+	rm -rf $(BINARY_NAME) *~ 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/README linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/README
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/README	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/README	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,68 @@
+# # ## # # #### ##### # # ##### # # # ##### # # 
+## ## # # # # # # # # # # # # # # # # 
+# ## # # # # # #### ##### # # # # # # # # 
+# # ###### # # # # # # # # # # # # # 
+# # # # # # # # # # # # # # # # # # 
+# # # # #### #### ##### #### # # ###### # # # 
+ 
+ 
+Author: Aymen Zayet 
+License: GPL2 
+Version: 0.1 
+ 
+1. Description 
+-------------- 
+This tool includes many commands that help to test / debug the MAUSB devices. 
+mausb bin provides to the host a way to connect and disconnect from the MAUSB device 
+by selecting the mode (ip or llc). 
+ 
+2. Usage 
+-------- 
+(*) The following steps can be used to test the connection between two Moorefield based devices : 
+ 
+>> adb devices 
+List of devices attached 
+INV140200379 device 
+INV140200169 device 
+ 
+for device INV140200379: 
+>>adb -s INV140200379 shell busybox ifconfig wlan0 
+wlan0 Link encap:Ethernet HWaddr 78:FF:57:00:6D:7A 
+ inet addr:192.168.2.100 Bcast:192.168.2.255 Mask:255.255.255.0 
+ inet6 addr: fe80::7aff:57ff:fe00:6d7a/64 Scope:Link 
+ UP BROADCAST RUNNING MULTICAST MTU:1500 Metric:1 
+ RX packets:264 errors:0 dropped:0 overruns:0 frame:0 
+ TX packets:287 errors:0 dropped:0 overruns:0 carrier:0 
+ collisions:0 txqueuelen:1000 
+ RX bytes:29906 (29.2 KiB) TX bytes:29267 (28.5 KiB) 
+ 
+for device INV140200169: 
+>> adb -s INV140200169 shell busybox ifconfig wlan0 
+wlan0 Link encap:Ethernet HWaddr 78:FF:57:00:6C:A8 
+ inet addr:192.168.2.113 Bcast:192.168.2.255 Mask:255.255.255.0 
+ inet6 addr: fe80::7aff:57ff:fe00:6ca8/64 Scope:Link 
+ UP BROADCAST RUNNING MULTICAST MTU:1500 Metric:1 
+ RX packets:268 errors:0 dropped:0 overruns:0 frame:0 
+ TX packets:290 errors:0 dropped:0 overruns:0 carrier:0 
+ collisions:0 txqueuelen:1000 
+ RX bytes:31168 (30.4 KiB) TX bytes:30413 (29.7 KiB) 
+ 
+run INV140200379 as a MAUSB host: 
+>> adb -s INV140200379 shell load_mausb_android-host.sh 
+mausb load process complete 
+ 
+then run INV140200169 as MAUSB device: 
+>>adb -s INV140200169 shell load_mausb_android-dev.sh 
+mausb load process complete 
+ 
+now on the device side , run : 
+>> mausb --mode llc --connect --addr 78:FF:57:00:6D:7A 
+ 
+then from the host side, run : 
+>> mausb --mode llc --connect --addr 78:FF:57:00:6C:A8 
+ 
+3. Documentation 
+---------------- 
+ 
+4. Miscellaneous 
+---------------- 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/src/Android.mk linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/src/Android.mk
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/src/Android.mk	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/src/Android.mk	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,13 @@
+LOCAL_PATH := $(call my-dir) 
+include $(CLEAR_VARS) 
+LOCAL_CFLAGS += -Wall -g 
+LOCAL_LDFLAGS += 
+LOCAL_LDLIBS += -lpthread -lm -ldl 
+LOCAL_SRC_FILES:= \ 
+ mausb.c \ 
+ utils.c \ 
+ connect.c 
+LOCAL_C_INCLUDES += linux/modules/ma-usb/drivers 
+LOCAL_MODULE := mausb 
+LOCAL_MODULE_TAGS := optional 
+include $(BUILD_EXECUTABLE) 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/src/connect.c linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/src/connect.c
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/src/connect.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/src/connect.c	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,69 @@
+/* 
+ (c) Aymen Zayet (aymen.zayet [at] intel) 
+ 
+ This file is part of mausb utility. 
+ 
+ mausb is free software: you can redistribute it and/or modify 
+ it under the terms of the GNU General Public License as published by 
+ the Free Software Foundation, either version 2 of the License, or 
+ (at your option) any later version. 
+ 
+ mausb is distributed in the hope that it will be useful, 
+ but WITHOUT ANY WARRANTY; without even the implied warranty of 
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
+ GNU General Public License for more details. 
+ 
+ You should have received a copy of the GNU General Public License 
+ along with mausb. If not, see <http://www.gnu.org/licenses/>. 
+*/ 
+#include "mausb.h" 
+ 
+int set_ipv4_addr(mausb_t *config) 
+{ 
+ char buf[128] = {0}; 
+ printf("%s: setting ip address\n", __func__); 
+ sprintf(buf, "%u", config->ip); 
+ if (0 <= ioctl(config->device, IOCTL_SET_IP, buf)) 
+ return 0; 
+ return errno; 
+} 
+ 
+int set_mac_addr(mausb_t *config) 
+{ 
+ char buf[128] = {0}; 
+ printf("%s: setting mac address\n", __func__); 
+ memcpy(buf, config->mac, 6); 
+ if (0 <= ioctl(config->device, IOCTL_SET_MAC, buf)) { 
+ printf("Msg from kernel space : mac %s set successfully\n", 
+ (char *)buf); 
+ return 0; 
+ } 
+ return errno; 
+} 
+int set_port(mausb_t *config) 
+{ 
+ char buf[128] = {0}; 
+ printf("%s: setting port\n", __func__); 
+ sprintf(buf, "%u", config->port); 
+ if (0 <= ioctl(config->device, IOCTL_SET_PORT, buf)) 
+ return 0; 
+ return errno; 
+} 
+ 
+int connect_device(mausb_t *config) 
+{ 
+ char buf[128] = {0}; 
+ printf("%s: connecting device\n", __func__); 
+ if (0 <= ioctl(config->device, IOCTL_GADGET_C, buf)) 
+ return 0; 
+ return errno; 
+} 
+ 
+int disconnect_device(mausb_t *config) 
+{ 
+ char buf[128] = {0}; 
+ printf("%s: disconnecting device\n", __func__); 
+ if (0 <= ioctl(config->device, IOCTL_GADGET_D, buf)) 
+ return 0; 
+ return errno; 
+} 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/src/connect.h linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/src/connect.h
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/src/connect.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/src/connect.h	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,22 @@
+/* 
+ (c) Aymen Zayet (aymen.zayet [at] intel) 
+ 
+ This file is part of mausb utility. 
+ 
+ mausb is free software: you can redistribute it and/or modify 
+ it under the terms of the GNU General Public License as published by 
+ the Free Software Foundation, either version 2 of the License, or 
+ (at your option) any later version. 
+ 
+ mausb is distributed in the hope that it will be useful, 
+ but WITHOUT ANY WARRANTY; without even the implied warranty of 
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
+ GNU General Public License for more details. 
+ 
+ You should have received a copy of the GNU General Public License 
+ along with mausb. If not, see <http://www.gnu.org/licenses/>. 
+*/ 
+#ifndef CONNECT_H_ 
+#define CONNECT_H_ 
+ 
+#endif /* CONNECT_H_ */ 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/src/Makefile linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/src/Makefile
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/src/Makefile	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/src/Makefile	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,17 @@
+include ../config.mk 
+ 
+all: $(BINARY_NAME) 
+ 
+$(BINARY_NAME): $(OBJECT_FILES) 
+	@echo -n "(LD)" $@ " " 
+	@$(CC) $(LDFLAGS) $(CFLAGS) $^ -o $@ 
+	@echo OK 
+ 
+%.o: %.c 
+	@echo -n "(CC)" $@ " " 
+	@$(CC) $(CFLAGS) -c $< -o $@ 
+	@echo OK 
+ 
+clean: 
+	rm -rf *.[oas] .*.flags *.ko .*.cmd .*.d .*.tmp *.mod.c .tmp_versions Module*.symvers 
+	rm -f $(BINARY_NAME) *~ 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/src/mausb.c linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/src/mausb.c
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/src/mausb.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/src/mausb.c	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,201 @@
+/* 
+ (c) Aymen Zayet (aymen.zayet [at] intel) 
+ 
+ This file is part of mausb utility. 
+ 
+ mausb is free software: you can redistribute it and/or modify 
+ it under the terms of the GNU General Public License as published by 
+ the Free Software Foundation, either version 2 of the License, or 
+ (at your option) any later version. 
+ 
+ mausb is distributed in the hope that it will be useful, 
+ but WITHOUT ANY WARRANTY; without even the implied warranty of 
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
+ GNU General Public License for more details. 
+ 
+ You should have received a copy of the GNU General Public License 
+ along with mausb. If not, see <http://www.gnu.org/licenses/>. 
+*/ 
+ 
+#include "mausb.h" 
+ 
+ 
+ 
+static struct option l_opts[] = { 
+ /* no_argument options */ 
+ {"help", no_argument, 0, 'h'}, 
+ {"verbose", no_argument, 0, 'v'}, 
+ {"connect", no_argument, 0, 'c'}, 
+ {"disconnect", no_argument, 0, 'd'}, 
+ 
+ /* required_argument options */ 
+ {"addr", required_argument, 0, 'a'}, 
+ {"port", required_argument, 0, 'p'}, 
+ {"mode", required_argument, 0, 'm'}, 
+ 
+ /* end */ 
+ {0, 0, 0, 0}, 
+}; 
+ 
+static void usage(const char *this) 
+{ 
+ fprintf(stderr, 
+ "Usage: " 
+ "\t%s [[options]] command" 
+ "\n\t\t [--help/-h] show this help" 
+ "\n\t\t [--verbose/-h] Add more trace about what's going on" 
+ "\n\t\t [--mode/-m] mausb mode to be used : ip (default) or llc" 
+ "\n\t\t [--connect/-c] connect to mausb device" 
+ "\n\t\t [--disconnect/-d] disconnect from mausb device" 
+ "\n\t\t [--port/-p] set the port number in case of tcp connection" 
+ "\n\t\t [--addr/-a] ip or mac address depending on the given mode" 
+ "\n", this); 
+ return ; 
+} 
+ 
+static int check_config(void) 
+{ 
+ int ret; 
+ 
+ if (config.cmd == disconnect) 
+ return 0; 
+ 
+ switch (config.mode) { 
+ case ip: 
+ ret = !config.port; 
+ break; 
+ case llc: 
+ ret = !config.mac; 
+ break; 
+ default: 
+ ret = !! config.mode; 
+ } 
+ 
+ return ((config.cmd > max_command) || 
+ (config.mode > supported_mode) || 
+ ret); 
+} 
+ 
+static void print_config(void) 
+{ 
+ return ; 
+} 
+ 
+static int process_options(int argc, char **argv) 
+{ 
+ int option; 
+ 
+ memset(&config, 0, sizeof(mausb_t)); 
+ config.mode = ip; 
+ while ((option = getopt_long(argc, argv, "hfp:a:cdvm:", l_opts, NULL)) != EOF) { 
+ switch(option) { 
+ case 'h': // help 
+ usage(argv[0]); 
+ exit(0); 
+ break; 
+ 
+ case 'v': // verbose 
+ config.verbose = 1; 
+ break; 
+ 
+ case 'c': // connect 
+ config.cmd = connect; 
+ break; 
+ 
+ case 'd': // disconnect 
+ config.cmd = disconnect; 
+ break; 
+ 
+ case 'm': // mode 
+ if (strlen(optarg) == 3 && !strncmp(optarg, "llc", 3)) 
+ config.mode = llc; 
+ else if (strlen(optarg) == 2 && !strncmp(optarg, "ip", 2)) 
+ config.mode = ip; 
+ else { 
+ fprintf(stderr, "could not determine mode\n"); 
+ goto err_options; 
+ } 
+ break; 
+ 
+ case 'a': // addr 
+ if (config.mode == llc) { 
+ if (MACADDR_STR_SIZE != strlen(optarg)) 
+ goto err_options; 
+ if (get_mac_address(optarg, config.mac)) 
+ goto err_options; 
+ } else { 
+ if (strlen(optarg) >= IPADDR_MAX) 
+ goto err_options; 
+ if (convert_ipv4_to_uint32(optarg, &config.ip)) 
+ goto err_options; 
+ strcpy(config.ip_addr, optarg); 
+ } 
+ break; 
+ 
+ case 'p': // port 
+ config.port = atoi(optarg); 
+ break; 
+ 
+ default: 
+ fprintf(stderr, "invalid option %c\n", option); 
+ goto err_options; 
+ break; 
+ } 
+ } 
+ 
+ if (check_config()) { 
+ fprintf(stderr, "check_config() failed\n"); 
+ goto err_options; 
+ } 
+ 
+ if (config.verbose) 
+ print_config(); 
+ 
+ return 0; 
+ 
+err_options: 
+ usage(argv[0]); 
+ return -1; 
+} 
+ 
+int main(int argc, char **argv) 
+{ 
+ int ret; 
+ 
+ if (ret = process_options(argc, argv)) 
+ goto error; 
+ 
+ printf("progran terminated successfully ip %x %s %d\n", config.ip, 
+ config.ip_addr, config.port); 
+ 
+ ret = config.device = open(MAUSB_DEVICE, 0); 
+ if (ret < 0) { 
+ fprintf(stderr, "cannot open device %d\n", ret); 
+ goto error; 
+ } 
+ 
+ switch(config.cmd) { 
+ case connect: 
+ if (config.verbose) 
+ printf("connecting to %s port %u\n", config.ip_addr, config.port); 
+ if (config.mode == llc) { 
+ if (ret = set_mac_addr(&config)) 
+ goto close_device; 
+ } else { 
+ if (ret = set_ipv4_addr(&config)) 
+ goto close_device; 
+ if (ret = set_port(&config)) 
+ goto close_device; 
+ } 
+ if (ret = connect_device(&config)) 
+ goto close_device; 
+ break; 
+ case disconnect: 
+ disconnect_device(&config); 
+ break; 
+ } 
+close_device: 
+ close(config.device); 
+error: 
+ return ret; 
+} 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/src/mausb.h linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/src/mausb.h
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/src/mausb.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/src/mausb.h	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,64 @@
+/* 
+ (c) Aymen Zayet (aymen.zayet [at] intel) 
+ 
+ This file is part of mausb utility. 
+ 
+ mausb is free software: you can redistribute it and/or modify 
+ it under the terms of the GNU General Public License as published by 
+ the Free Software Foundation, either version 2 of the License, or 
+ (at your option) any later version. 
+ 
+ mausb is distributed in the hope that it will be useful, 
+ but WITHOUT ANY WARRANTY; without even the implied warranty of 
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
+ GNU General Public License for more details. 
+ 
+ You should have received a copy of the GNU General Public License 
+ along with mausb. If not, see <http://www.gnu.org/licenses/>. 
+*/ 
+#ifndef MAUSB_H_ 
+#define MAUSB_H_ 
+ 
+#include <unistd.h> 
+#include <stdlib.h> 
+#include <string.h> 
+#include <errno.h> 
+#include <stdint.h> 
+#include <stdio.h> 
+#include <getopt.h> 
+#include <sys/ioctl.h> 
+#include "connect.h" 
+#include "mausb_ioctl.h" 
+ 
+#define MAUSB_DEVICE "/dev/mausb" 
+#define IPADDR_MAX 16 
+#define MACADDR_STR_SIZE 17 /* excluding null termination char */ 
+ 
+typedef enum { 
+ connect, 
+ disconnect, 
+ max_command, 
+} mausb_cmd; 
+ 
+typedef enum { 
+ ip, 
+ llc, 
+ supported_mode, 
+} mausb_mode; 
+ 
+typedef struct { 
+ int device; // file descriptor of the mausb device 
+ char verbose; // is verbose mode enabled 
+ mausb_cmd cmd; // keep the requested command to execute 
+ uint32_t ip; // ip address of the device in case of ip mode 
+ char ip_addr[IPADDR_MAX]; // ip address given in cmdline (x.x.x.x) 
+ uint8_t mac[6]; // mac address (aa:bb:cc:dd:ee:ff) 
+ uint32_t port; // ip port number in case of ip mode 
+ mausb_mode mode; // default is ip 
+} mausb_t; 
+ 
+mausb_t config; 
+int convert_ipv4_to_uint32(char *, uint32_t *); 
+ 
+int get_mac_address(char *, uint8_t *); 
+#endif /* MAUSB_H_ */ 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/src/mausb_ioctl.h linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/src/mausb_ioctl.h
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/src/mausb_ioctl.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/src/mausb_ioctl.h	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,24 @@
+#ifndef MAUSB_IOCTL_H 
+#define MAUSB_IOCTL_H 
+ 
+#define BUFFER 80 
+#define DRIVER_VERSION "Alpha 0.0.25" 
+#define MAJOR_NUM 100 
+ 
+/* These define the ioctl functions that can be used */ 
+#define IOCTL_GET_VRSN _IOR(MAJOR_NUM, 0, char *) 
+#define IOCTL_GET_NAME _IOR(MAJOR_NUM, 1, char *) 
+#define IOCTL_GADGET_C _IOR(MAJOR_NUM, 2, char *) 
+#define IOCTL_GADGET_D _IOR(MAJOR_NUM, 3, char *) 
+#define IOCTL_SET_IP _IOR(MAJOR_NUM, 4, char *) 
+#define IOCTL_SET_PORT _IOR(MAJOR_NUM, 5, char *) 
+#define IOCTL_SET_MAC _IOR(MAJOR_NUM, 6, char *) 
+ 
+ 
+/* This is the location where the device file will be created. It is used to 
+ * read/write to in order to communicate to and from the device */ 
+#define DEVICE_FILE_NAME "/dev/mausb" 
+ 
+#define ETH_ALEN 6 
+ 
+#endif 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/src/utils.c linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/src/utils.c
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/mausb-util/src/utils.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/mausb-util/src/utils.c	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,94 @@
+/* 
+ (c) Aymen Zayet (aymen.zayet [at] intel) 
+ 
+ This file is part of mausb utility. 
+ 
+ mausb is free software: you can redistribute it and/or modify 
+ it under the terms of the GNU General Public License as published by 
+ the Free Software Foundation, either version 2 of the License, or 
+ (at your option) any later version. 
+ 
+ mausb is distributed in the hope that it will be useful, 
+ but WITHOUT ANY WARRANTY; without even the implied warranty of 
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
+ GNU General Public License for more details. 
+ 
+ You should have received a copy of the GNU General Public License 
+ along with mausb. If not, see <http://www.gnu.org/licenses/>. 
+*/ 
+#include "mausb.h" 
+ 
+int convert_ipv4_to_uint32(char *addr, uint32_t *ipnum) 
+{ 
+ uint8_t digits[4]; 
+ int i, j = 0; 
+ char ip[64]; 
+ 
+ if (addr == NULL) 
+ goto input_err; 
+ 
+ strncpy(ip, addr, strlen(addr)+1); 
+ i = strlen(ip); 
+ memset(digits, 0, 4); 
+ 
+ if (IPADDR_MAX < strlen(ip)) 
+ goto input_err; 
+ 
+again: 
+ while (i-1 && ip[--i - 1] != '.'); 
+ if (i-1) { 
+ ip[i-1] = '\0'; 
+ digits[j++] = atoi(ip+i); 
+ goto again; 
+ } else 
+ digits[j++] = atoi(ip); 
+ 
+ *ipnum = digits[3] << 24 | 
+ digits[2] << 16 | 
+ digits[1] << 8 | 
+ digits[0] << 0; 
+ 
+ return 0; 
+ 
+input_err: 
+ return -1; 
+} 
+ 
+ 
+int get_mac_address(char *addr, uint8_t *out) 
+{ 
+ 
+ uint8_t digits[6]; 
+ int i, j = 0; 
+ char mac[64]; 
+ 
+ if (addr == NULL) 
+ goto input_err; 
+ 
+ strncpy(mac, addr, strlen(addr)+1); 
+ i = strlen(mac); 
+ memset(digits, 0, 6); 
+ 
+ if (MACADDR_STR_SIZE != strlen(mac)) 
+ goto input_err; 
+ 
+again: 
+ while (i-1 && mac[--i - 1] != ':'); 
+ if (i-1) { 
+ mac[i-1] = '\0'; 
+ digits[j++] = strtol(mac+i, NULL, 16); 
+ goto again; 
+ } else 
+ digits[j++] = strtol(mac, NULL, 16); 
+ 
+ for (i = 0; i < 6; i++) { 
+ printf("[%d]=0x%x ", i, digits[i]); 
+ out[5-i] = digits[i]; 
+ } 
+ 
+ printf("\n"); 
+ return 0; 
+ 
+input_err: 
+ return -1; 
+} 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/Android.mk linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/Android.mk
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/Android.mk	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/Android.mk	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,38 @@
+LOCAL_PATH := $(call my-dir) 
+ 
+include $(CLEAR_VARS) 
+LOCAL_MODULE := load_mausb_android.sh 
+LOCAL_MODULE_TAGS := optional 
+LOCAL_SRC_FILES := $(LOCAL_MODULE) 
+LOCAL_MODULE_CLASS := EXECUTABLE 
+ 
+ifeq ($(TARGET_OUT_EXECUTABLE),) 
+TARGET_OUT_EXECUTABLE := $(TARGET_OUT)/bin 
+endif 
+ 
+include $(BUILD_PREBUILT) 
+ 
+include $(CLEAR_VARS) 
+ 
+LOCAL_MODULE := load_mausb_android-host.sh 
+LOCAL_MODULE_TAGS := optional 
+LOCAL_SRC_FILES := $(LOCAL_MODULE) 
+LOCAL_MODULE_CLASS := EXECUTABLE 
+ 
+ifeq ($(TARGET_OUT_EXECUTABLE),) 
+TARGET_OUT_EXECUTABLE := $(TARGET_OUT)/bin 
+endif 
+ 
+include $(BUILD_PREBUILT) 
+ 
+include $(CLEAR_VARS) 
+LOCAL_MODULE := load_mausb_android-dev.sh 
+LOCAL_MODULE_TAGS := optional 
+LOCAL_SRC_FILES := $(LOCAL_MODULE) 
+LOCAL_MODULE_CLASS := EXECUTABLE 
+ 
+ifeq ($(TARGET_OUT_EXECUTABLE),) 
+TARGET_OUT_EXECUTABLE := $(TARGET_OUT)/bin 
+endif 
+ 
+include $(BUILD_PREBUILT) 
\ No newline at end of file
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/scripts/build_load_connect.sh linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/scripts/build_load_connect.sh
